/*******************************************************************
*
*  DESCRIPTION:
*
*  AUTHOR:
*
*  EMAIL:
*
*  DATE:
*
*******************************************************************/

#ifndef __AISLEUNLOCKED_H
#define __AISLEUNLOCKED_H

#include <list>
#include "atomic.h"     // class Atomic

class AisleUnlocked : public Atomic
{
public:
	AisleUnlocked( const string &name = "AisleUnlocked" );					//Default constructor

	virtual string className() const ;
protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	const Port &onExit;
	const Port &reset;
	Port &stop;
	Port &onReset;
	Time preparationTime;
//	Time initialTime;
	int count;
	bool ifExit;
	bool ifReset;


};	// class AisleUnlocked

// ** inline ** //
inline
string AisleUnlocked::className() const
{
	return "AisleUnlocked" ;
}

#endif   //__AISLEUNLOCKED_H
